/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleCloudStorageRequestAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleCloudStorageRequestAllOf{}

// GoogleCloudStorageRequestAllOf struct for GoogleCloudStorageRequestAllOf
type GoogleCloudStorageRequestAllOf struct {
	OAuthId *int32         `json:"o_auth_id,omitempty"`
	Bucket  *string        `json:"bucket,omitempty"`
	Path    NullableString `json:"path,omitempty"`
}

// NewGoogleCloudStorageRequestAllOf instantiates a new GoogleCloudStorageRequestAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleCloudStorageRequestAllOf() *GoogleCloudStorageRequestAllOf {
	this := GoogleCloudStorageRequestAllOf{}
	return &this
}

// NewGoogleCloudStorageRequestAllOfWithDefaults instantiates a new GoogleCloudStorageRequestAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleCloudStorageRequestAllOfWithDefaults() *GoogleCloudStorageRequestAllOf {
	this := GoogleCloudStorageRequestAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleCloudStorageRequestAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCloudStorageRequestAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleCloudStorageRequestAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *GoogleCloudStorageRequestAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetBucket returns the Bucket field value if set, zero value otherwise.
func (o *GoogleCloudStorageRequestAllOf) GetBucket() string {
	if o == nil || IsNil(o.Bucket) {
		var ret string
		return ret
	}
	return *o.Bucket
}

// GetBucketOk returns a tuple with the Bucket field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCloudStorageRequestAllOf) GetBucketOk() (*string, bool) {
	if o == nil || IsNil(o.Bucket) {
		return nil, false
	}
	return o.Bucket, true
}

// HasBucket returns a boolean if a field has been set.
func (o *GoogleCloudStorageRequestAllOf) HasBucket() bool {
	if o != nil && !IsNil(o.Bucket) {
		return true
	}

	return false
}

// SetBucket gets a reference to the given string and assigns it to the Bucket field.
func (o *GoogleCloudStorageRequestAllOf) SetBucket(v string) {
	o.Bucket = &v
}

// GetPath returns the Path field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GoogleCloudStorageRequestAllOf) GetPath() string {
	if o == nil || IsNil(o.Path.Get()) {
		var ret string
		return ret
	}
	return *o.Path.Get()
}

// GetPathOk returns a tuple with the Path field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GoogleCloudStorageRequestAllOf) GetPathOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Path.Get(), o.Path.IsSet()
}

// HasPath returns a boolean if a field has been set.
func (o *GoogleCloudStorageRequestAllOf) HasPath() bool {
	if o != nil && o.Path.IsSet() {
		return true
	}

	return false
}

// SetPath gets a reference to the given NullableString and assigns it to the Path field.
func (o *GoogleCloudStorageRequestAllOf) SetPath(v string) {
	o.Path.Set(&v)
}

// SetPathNil sets the value for Path to be an explicit nil
func (o *GoogleCloudStorageRequestAllOf) SetPathNil() {
	o.Path.Set(nil)
}

// UnsetPath ensures that no value is present for Path, not even an explicit nil
func (o *GoogleCloudStorageRequestAllOf) UnsetPath() {
	o.Path.Unset()
}

func (o GoogleCloudStorageRequestAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleCloudStorageRequestAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.Bucket) {
		toSerialize["bucket"] = o.Bucket
	}
	if o.Path.IsSet() {
		toSerialize["path"] = o.Path.Get()
	}
	return toSerialize, nil
}

type NullableGoogleCloudStorageRequestAllOf struct {
	value *GoogleCloudStorageRequestAllOf
	isSet bool
}

func (v NullableGoogleCloudStorageRequestAllOf) Get() *GoogleCloudStorageRequestAllOf {
	return v.value
}

func (v *NullableGoogleCloudStorageRequestAllOf) Set(val *GoogleCloudStorageRequestAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleCloudStorageRequestAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleCloudStorageRequestAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleCloudStorageRequestAllOf(val *GoogleCloudStorageRequestAllOf) *NullableGoogleCloudStorageRequestAllOf {
	return &NullableGoogleCloudStorageRequestAllOf{value: val, isSet: true}
}

func (v NullableGoogleCloudStorageRequestAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleCloudStorageRequestAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
